
From: Arnd Bergmann <arnd@arndb.de>

Dave Jones already removed some of the useless __KERNEL_SYSCALLS__ defines
in various files, this gets rid of almost all the others.  Replacing
execve() is nontrivial, so I left those in for now.

For all the other system calls that are currently used from inside the
kernel, calling the sys_* function directly should always have an identical
effect.

tested on s390 and x86_64.
DESC
build fix for remove-more-KERNEL_SYSCALLS.patch
EDESC

In file included from init/main.c:45:
include/asm/unistd.h: In function `setsid':
include/asm/unistd.h:393: error: `errno' undeclared (first use in this function)
DESC
fix the build for remove-more-KERNEL_SYSCALLS
EDESC

In file included from include/linux/unistd.h:10,
                 from init/do_mounts_initrd.c:3:
include/asm/unistd.h:402: error: syntax error before "int"
include/asm/unistd.h:403: error: syntax error before "long"
include/asm/unistd.h:406: error: syntax error before "int"



---

 arch/alpha/kernel/alpha_ksyms.c          |    3 ---
 arch/alpha/kernel/smp.c                  |    3 ---
 arch/cris/kernel/process.c               |    2 --
 arch/parisc/kernel/process.c             |    1 -
 arch/parisc/kernel/smp.c                 |    1 -
 arch/ppc/kernel/misc.S                   |   10 ----------
 arch/ppc/kernel/ppc_ksyms.c              |    6 ------
 arch/ppc/kernel/smp.c                    |    2 --
 arch/ppc/platforms/chrp_smp.c            |    2 --
 arch/ppc/platforms/pmac_smp.c            |    2 --
 arch/ppc64/kernel/misc.S                 |   10 ----------
 arch/ppc64/kernel/pmac_smp.c             |    2 --
 arch/sparc/kernel/process.c              |    2 --
 arch/sparc/kernel/smp.c                  |    3 ---
 arch/sparc/kernel/sun4d_smp.c            |    3 ---
 arch/sparc/kernel/sun4m_smp.c            |    3 ---
 arch/sparc64/kernel/process.c            |    2 --
 arch/sparc64/kernel/smp.c                |    3 ---
 arch/x86_64/kernel/process.c             |    2 --
 drivers/macintosh/mediabay.c             |    3 ---
 drivers/media/dvb/frontends/alps_tdlb7.c |   12 ++++--------
 drivers/media/dvb/frontends/sp887x.c     |   11 ++++-------
 drivers/media/dvb/frontends/tda1004x.c   |   10 ++++------
 drivers/scsi/cpqfcTSinit.c               |    4 ----
 drivers/scsi/oktagon_esp.c               |    3 ---
 include/asm-i386/unistd.h                |    1 +
 init/do_mounts.c                         |   24 ++++++++++++------------
 init/do_mounts.h                         |    1 -
 init/do_mounts_devfs.c                   |    8 ++++----
 init/do_mounts_initrd.c                  |   29 +++++++++++++++--------------
 init/do_mounts_md.c                      |   10 +++++-----
 init/do_mounts_rd.c                      |   30 +++++++++++++++---------------
 init/initramfs.c                         |    2 --
 init/main.c                              |    8 ++++----
 sound/isa/wavefront/wavefront_synth.c    |   12 ++++++------
 sound/oss/wavfront.c                     |   12 +++++-------
 36 files changed, 79 insertions(+), 163 deletions(-)

diff -puN arch/alpha/kernel/alpha_ksyms.c~remove-more-KERNEL_SYSCALLS arch/alpha/kernel/alpha_ksyms.c
--- 25/arch/alpha/kernel/alpha_ksyms.c~remove-more-KERNEL_SYSCALLS	2004-03-07 00:17:21.000000000 -0800
+++ 25-akpm/arch/alpha/kernel/alpha_ksyms.c	2004-03-07 00:17:21.000000000 -0800
@@ -35,9 +35,6 @@
 #include <asm/cacheflush.h>
 #include <asm/vga.h>
 
-#define __KERNEL_SYSCALLS__
-#include <asm/unistd.h>
-
 extern struct hwrpb_struct *hwrpb;
 extern void dump_thread(struct pt_regs *, struct user *);
 extern spinlock_t rtc_lock;
diff -puN arch/alpha/kernel/smp.c~remove-more-KERNEL_SYSCALLS arch/alpha/kernel/smp.c
--- 25/arch/alpha/kernel/smp.c~remove-more-KERNEL_SYSCALLS	2004-03-07 00:17:21.000000000 -0800
+++ 25-akpm/arch/alpha/kernel/smp.c	2004-03-07 00:17:21.000000000 -0800
@@ -39,9 +39,6 @@
 #include <asm/mmu_context.h>
 #include <asm/tlbflush.h>
 
-#define __KERNEL_SYSCALLS__
-#include <asm/unistd.h>
-
 #include "proto.h"
 #include "irq_impl.h"
 
diff -puN arch/cris/kernel/process.c~remove-more-KERNEL_SYSCALLS arch/cris/kernel/process.c
--- 25/arch/cris/kernel/process.c~remove-more-KERNEL_SYSCALLS	2004-03-07 00:17:21.000000000 -0800
+++ 25-akpm/arch/cris/kernel/process.c	2004-03-07 00:17:21.000000000 -0800
@@ -91,8 +91,6 @@
  * This file handles the architecture-dependent parts of process handling..
  */
 
-#define __KERNEL_SYSCALLS__
-
 #include <asm/atomic.h>
 #include <asm/pgtable.h>
 #include <asm/uaccess.h>
diff -puN arch/parisc/kernel/process.c~remove-more-KERNEL_SYSCALLS arch/parisc/kernel/process.c
--- 25/arch/parisc/kernel/process.c~remove-more-KERNEL_SYSCALLS	2004-03-07 00:17:21.000000000 -0800
+++ 25-akpm/arch/parisc/kernel/process.c	2004-03-07 00:17:21.000000000 -0800
@@ -32,7 +32,6 @@
  *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  */
 
-#define __KERNEL_SYSCALLS__
 #include <stdarg.h>
 
 #include <linux/elf.h>
diff -puN arch/parisc/kernel/smp.c~remove-more-KERNEL_SYSCALLS arch/parisc/kernel/smp.c
--- 25/arch/parisc/kernel/smp.c~remove-more-KERNEL_SYSCALLS	2004-03-07 00:17:21.000000000 -0800
+++ 25-akpm/arch/parisc/kernel/smp.c	2004-03-07 00:17:21.000000000 -0800
@@ -16,7 +16,6 @@
 **      the Free Software Foundation; either version 2 of the License, or
 **      (at your option) any later version.
 */
-#define __KERNEL_SYSCALLS__
 #undef ENTRY_SYS_CPUS	/* syscall support for iCOD-like functionality */
 
 #include <linux/autoconf.h>
diff -puN arch/ppc64/kernel/misc.S~remove-more-KERNEL_SYSCALLS arch/ppc64/kernel/misc.S
--- 25/arch/ppc64/kernel/misc.S~remove-more-KERNEL_SYSCALLS	2004-03-07 00:17:21.000000000 -0800
+++ 25-akpm/arch/ppc64/kernel/misc.S	2004-03-07 00:17:21.000000000 -0800
@@ -582,17 +582,7 @@ _GLOBAL(name) \
 	li	r3,-1; \
 	blr
 
-#define __NR__exit __NR_exit
-
-SYSCALL(setsid)
-SYSCALL(open)
-SYSCALL(read)
-SYSCALL(write)
-SYSCALL(lseek)
-SYSCALL(close)
-SYSCALL(dup)
 SYSCALL(execve)
-SYSCALL(waitpid)
 
 #ifdef CONFIG_PPC_ISERIES	/* hack hack hack */
 #define ppc_rtas	sys_ni_syscall
diff -puN arch/ppc64/kernel/pmac_smp.c~remove-more-KERNEL_SYSCALLS arch/ppc64/kernel/pmac_smp.c
--- 25/arch/ppc64/kernel/pmac_smp.c~remove-more-KERNEL_SYSCALLS	2004-03-07 00:17:21.000000000 -0800
+++ 25-akpm/arch/ppc64/kernel/pmac_smp.c	2004-03-07 00:17:21.000000000 -0800
@@ -29,8 +29,6 @@
 #include <linux/interrupt.h>
 #include <linux/kernel_stat.h>
 #include <linux/delay.h>
-#define __KERNEL_SYSCALLS__
-#include <linux/unistd.h>
 #include <linux/init.h>
 #include <linux/spinlock.h>
 #include <linux/errno.h>
diff -puN arch/ppc/kernel/misc.S~remove-more-KERNEL_SYSCALLS arch/ppc/kernel/misc.S
--- 25/arch/ppc/kernel/misc.S~remove-more-KERNEL_SYSCALLS	2004-03-07 00:17:21.000000000 -0800
+++ 25-akpm/arch/ppc/kernel/misc.S	2004-03-07 00:17:21.000000000 -0800
@@ -1108,17 +1108,7 @@ _GLOBAL(name) \
 	li	r3,-1; \
 	blr
 
-#define __NR__exit __NR_exit
-
-SYSCALL(setsid)
-SYSCALL(open)
-SYSCALL(read)
-SYSCALL(write)
-SYSCALL(lseek)
-SYSCALL(close)
-SYSCALL(dup)
 SYSCALL(execve)
-SYSCALL(waitpid)
 
 /* Why isn't this a) automatic, b) written in 'C'? */
 	.data
diff -puN arch/ppc/kernel/ppc_ksyms.c~remove-more-KERNEL_SYSCALLS arch/ppc/kernel/ppc_ksyms.c
--- 25/arch/ppc/kernel/ppc_ksyms.c~remove-more-KERNEL_SYSCALLS	2004-03-07 00:17:21.000000000 -0800
+++ 25-akpm/arch/ppc/kernel/ppc_ksyms.c	2004-03-07 00:17:21.000000000 -0800
@@ -32,8 +32,6 @@
 #include <linux/pmu.h>
 #include <asm/prom.h>
 #include <asm/system.h>
-#define __KERNEL_SYSCALLS__
-#include <asm/unistd.h>
 #include <asm/pci-bridge.h>
 #include <asm/irq.h>
 #include <asm/pmac_feature.h>
@@ -189,10 +187,6 @@ EXPORT_SYMBOL(consistent_sync);
 EXPORT_SYMBOL(flush_dcache_all);
 #endif
 
-EXPORT_SYMBOL(open);
-EXPORT_SYMBOL(read);
-EXPORT_SYMBOL(lseek);
-EXPORT_SYMBOL(close);
 EXPORT_SYMBOL(start_thread);
 EXPORT_SYMBOL(kernel_thread);
 
diff -puN arch/ppc/kernel/smp.c~remove-more-KERNEL_SYSCALLS arch/ppc/kernel/smp.c
--- 25/arch/ppc/kernel/smp.c~remove-more-KERNEL_SYSCALLS	2004-03-07 00:17:21.000000000 -0800
+++ 25-akpm/arch/ppc/kernel/smp.c	2004-03-07 00:17:21.000000000 -0800
@@ -17,8 +17,6 @@
 #include <linux/interrupt.h>
 #include <linux/kernel_stat.h>
 #include <linux/delay.h>
-#define __KERNEL_SYSCALLS__
-#include <linux/unistd.h>
 #include <linux/init.h>
 #include <linux/spinlock.h>
 #include <linux/cache.h>
diff -puN arch/ppc/platforms/chrp_smp.c~remove-more-KERNEL_SYSCALLS arch/ppc/platforms/chrp_smp.c
--- 25/arch/ppc/platforms/chrp_smp.c~remove-more-KERNEL_SYSCALLS	2004-03-07 00:17:21.000000000 -0800
+++ 25-akpm/arch/ppc/platforms/chrp_smp.c	2004-03-07 00:17:21.000000000 -0800
@@ -16,8 +16,6 @@
 #include <linux/interrupt.h>
 #include <linux/kernel_stat.h>
 #include <linux/delay.h>
-#define __KERNEL_SYSCALLS__
-#include <linux/unistd.h>
 #include <linux/init.h>
 #include <linux/spinlock.h>
 
diff -puN arch/ppc/platforms/pmac_smp.c~remove-more-KERNEL_SYSCALLS arch/ppc/platforms/pmac_smp.c
--- 25/arch/ppc/platforms/pmac_smp.c~remove-more-KERNEL_SYSCALLS	2004-03-07 00:17:21.000000000 -0800
+++ 25-akpm/arch/ppc/platforms/pmac_smp.c	2004-03-07 00:17:21.000000000 -0800
@@ -29,8 +29,6 @@
 #include <linux/interrupt.h>
 #include <linux/kernel_stat.h>
 #include <linux/delay.h>
-#define __KERNEL_SYSCALLS__
-#include <linux/unistd.h>
 #include <linux/init.h>
 #include <linux/spinlock.h>
 #include <linux/errno.h>
diff -puN arch/sparc64/kernel/process.c~remove-more-KERNEL_SYSCALLS arch/sparc64/kernel/process.c
--- 25/arch/sparc64/kernel/process.c~remove-more-KERNEL_SYSCALLS	2004-03-07 00:17:21.000000000 -0800
+++ 25-akpm/arch/sparc64/kernel/process.c	2004-03-07 00:17:21.000000000 -0800
@@ -10,7 +10,6 @@
  * This file handles the architecture-dependent parts of process handling..
  */
 
-#define __KERNEL_SYSCALLS__
 #include <stdarg.h>
 
 #include <linux/errno.h>
@@ -22,7 +21,6 @@
 #include <linux/smp.h>
 #include <linux/smp_lock.h>
 #include <linux/stddef.h>
-#include <linux/unistd.h>
 #include <linux/ptrace.h>
 #include <linux/slab.h>
 #include <linux/user.h>
diff -puN arch/sparc64/kernel/smp.c~remove-more-KERNEL_SYSCALLS arch/sparc64/kernel/smp.c
--- 25/arch/sparc64/kernel/smp.c~remove-more-KERNEL_SYSCALLS	2004-03-07 00:17:21.000000000 -0800
+++ 25-akpm/arch/sparc64/kernel/smp.c	2004-03-07 00:17:21.000000000 -0800
@@ -36,9 +36,6 @@
 #include <asm/timer.h>
 #include <asm/starfire.h>
 
-#define __KERNEL_SYSCALLS__
-#include <linux/unistd.h>
-
 extern int linux_num_cpus;
 extern void calibrate_delay(void);
 
diff -puN arch/sparc/kernel/process.c~remove-more-KERNEL_SYSCALLS arch/sparc/kernel/process.c
--- 25/arch/sparc/kernel/process.c~remove-more-KERNEL_SYSCALLS	2004-03-07 00:17:21.000000000 -0800
+++ 25-akpm/arch/sparc/kernel/process.c	2004-03-07 00:17:21.000000000 -0800
@@ -9,7 +9,6 @@
  * This file handles the architecture-dependent parts of process handling..
  */
 
-#define __KERNEL_SYSCALLS__
 #include <stdarg.h>
 
 #include <linux/errno.h>
@@ -19,7 +18,6 @@
 #include <linux/kallsyms.h>
 #include <linux/mm.h>
 #include <linux/stddef.h>
-#include <linux/unistd.h>
 #include <linux/ptrace.h>
 #include <linux/slab.h>
 #include <linux/user.h>
diff -puN arch/sparc/kernel/smp.c~remove-more-KERNEL_SYSCALLS arch/sparc/kernel/smp.c
--- 25/arch/sparc/kernel/smp.c~remove-more-KERNEL_SYSCALLS	2004-03-07 00:17:21.000000000 -0800
+++ 25-akpm/arch/sparc/kernel/smp.c	2004-03-07 00:17:21.000000000 -0800
@@ -33,9 +33,6 @@
 #include <asm/cacheflush.h>
 #include <asm/tlbflush.h>
 
-#define __KERNEL_SYSCALLS__
-#include <linux/unistd.h>
-
 #define IRQ_RESCHEDULE		13
 #define IRQ_STOP_CPU		14
 #define IRQ_CROSS_CALL		15
diff -puN arch/sparc/kernel/sun4d_smp.c~remove-more-KERNEL_SYSCALLS arch/sparc/kernel/sun4d_smp.c
--- 25/arch/sparc/kernel/sun4d_smp.c~remove-more-KERNEL_SYSCALLS	2004-03-07 00:17:21.000000000 -0800
+++ 25-akpm/arch/sparc/kernel/sun4d_smp.c	2004-03-07 00:17:21.000000000 -0800
@@ -32,9 +32,6 @@
 #include <asm/sbus.h>
 #include <asm/sbi.h>
 
-#define __KERNEL_SYSCALLS__
-#include <linux/unistd.h>
-
 #define IRQ_CROSS_CALL		15
 
 extern ctxd_t *srmmu_ctx_table_phys;
diff -puN arch/sparc/kernel/sun4m_smp.c~remove-more-KERNEL_SYSCALLS arch/sparc/kernel/sun4m_smp.c
--- 25/arch/sparc/kernel/sun4m_smp.c~remove-more-KERNEL_SYSCALLS	2004-03-07 00:17:21.000000000 -0800
+++ 25-akpm/arch/sparc/kernel/sun4m_smp.c	2004-03-07 00:17:21.000000000 -0800
@@ -27,9 +27,6 @@
 #include <asm/oplib.h>
 #include <asm/hardirq.h>
 
-#define __KERNEL_SYSCALLS__
-#include <linux/unistd.h>
-
 #define IRQ_RESCHEDULE		13
 #define IRQ_STOP_CPU		14
 #define IRQ_CROSS_CALL		15
diff -puN arch/x86_64/kernel/process.c~remove-more-KERNEL_SYSCALLS arch/x86_64/kernel/process.c
--- 25/arch/x86_64/kernel/process.c~remove-more-KERNEL_SYSCALLS	2004-03-07 00:17:21.000000000 -0800
+++ 25-akpm/arch/x86_64/kernel/process.c	2004-03-07 00:17:21.000000000 -0800
@@ -16,7 +16,6 @@
  * This file handles the architecture-dependent parts of process handling..
  */
 
-#define __KERNEL_SYSCALLS__
 #include <stdarg.h>
 
 #include <linux/errno.h>
@@ -25,7 +24,6 @@
 #include <linux/mm.h>
 #include <linux/elfcore.h>
 #include <linux/smp.h>
-#include <linux/unistd.h>
 #include <linux/slab.h>
 #include <linux/user.h>
 #include <linux/module.h>
diff -puN drivers/macintosh/mediabay.c~remove-more-KERNEL_SYSCALLS drivers/macintosh/mediabay.c
--- 25/drivers/macintosh/mediabay.c~remove-more-KERNEL_SYSCALLS	2004-03-07 00:17:21.000000000 -0800
+++ 25-akpm/drivers/macintosh/mediabay.c	2004-03-07 00:17:21.000000000 -0800
@@ -10,8 +10,6 @@
  *  as published by the Free Software Foundation; either version
  *  2 of the License, or (at your option) any later version.
  */
-#define __KERNEL_SYSCALLS__
-
 #include <linux/config.h>
 #include <linux/types.h>
 #include <linux/errno.h>
@@ -21,7 +19,6 @@
 #include <linux/timer.h>
 #include <linux/hdreg.h>
 #include <linux/stddef.h>
-#include <linux/unistd.h>
 #include <linux/init.h>
 #include <linux/ide.h>
 #include <asm/prom.h>
diff -puN drivers/media/dvb/frontends/alps_tdlb7.c~remove-more-KERNEL_SYSCALLS drivers/media/dvb/frontends/alps_tdlb7.c
--- 25/drivers/media/dvb/frontends/alps_tdlb7.c~remove-more-KERNEL_SYSCALLS	2004-03-07 00:17:21.000000000 -0800
+++ 25-akpm/drivers/media/dvb/frontends/alps_tdlb7.c	2004-03-07 00:17:21.000000000 -0800
@@ -29,8 +29,6 @@
 */  
 
 
-
-#define __KERNEL_SYSCALLS__
 #include <linux/module.h>
 #include <linux/init.h>
 #include <linux/vmalloc.h>
@@ -58,8 +56,6 @@ static int debug = 0;
 #define SP8870_FIRMWARE_OFFSET 0x0A
 
 
-static int errno;
-
 static struct dvb_frontend_info tdlb7_info = {
 	.name			= "Alps TDLB7",
 	.type			= FE_OFDM,
@@ -174,13 +170,13 @@ static int sp8870_read_firmware_file (co
 	loff_t filesize;
 	char *dp;
 
-	fd = open(fn, 0, 0);
+	fd = sys_open(fn, 0, 0);
 	if (fd == -1) {
                 printk("%s: unable to open '%s'.\n", __FUNCTION__, fn);
 		return -EIO;
 	}
 
-	filesize = lseek(fd, 0L, 2);
+	filesize = sys_lseek(fd, 0L, 2);
 	if (filesize <= 0 || filesize < SP8870_FIRMWARE_OFFSET + SP8870_FIRMWARE_SIZE) {
 	        printk("%s: firmware filesize to small '%s'\n", __FUNCTION__, fn);
 		sys_close(fd);
@@ -194,8 +190,8 @@ static int sp8870_read_firmware_file (co
 		return -EIO;
 	}
 
-	lseek(fd, SP8870_FIRMWARE_OFFSET, 0);
-	if (read(fd, dp, SP8870_FIRMWARE_SIZE) != SP8870_FIRMWARE_SIZE) {
+	sys_lseek(fd, SP8870_FIRMWARE_OFFSET, 0);
+	if (sys_read(fd, dp, SP8870_FIRMWARE_SIZE) != SP8870_FIRMWARE_SIZE) {
 		printk("%s: failed to read '%s'.\n",__FUNCTION__, fn);
 		vfree(dp);
 		sys_close(fd);
diff -puN drivers/media/dvb/frontends/sp887x.c~remove-more-KERNEL_SYSCALLS drivers/media/dvb/frontends/sp887x.c
--- 25/drivers/media/dvb/frontends/sp887x.c~remove-more-KERNEL_SYSCALLS	2004-03-07 00:17:21.000000000 -0800
+++ 25-akpm/drivers/media/dvb/frontends/sp887x.c	2004-03-07 00:17:21.000000000 -0800
@@ -12,7 +12,6 @@
    next 0x4000 loaded. This may change in future versions.
  */
 
-#define __KERNEL_SYSCALLS__
 #include <linux/kernel.h>
 #include <linux/vmalloc.h>
 #include <linux/module.h>
@@ -68,8 +67,6 @@ struct dvb_frontend_info sp887x_info = {
 		FE_CAN_QPSK | FE_CAN_QAM_16 | FE_CAN_QAM_64 | FE_CAN_RECOVER
 };
 
-static int errno;
-
 static
 int i2c_writebytes (struct dvb_frontend *fe, u8 addr, u8 *buf, u8 len)
 {
@@ -216,13 +213,13 @@ int sp887x_initial_setup (struct dvb_fro
 
 	// Load the firmware
 	set_fs(get_ds());
-	fd = open(sp887x_firmware, 0, 0);
+	fd = sys_open(sp887x_firmware, 0, 0);
 	if (fd < 0) {
 		printk(KERN_WARNING "%s: Unable to open firmware %s\n", __FUNCTION__,
 		       sp887x_firmware);
 		return -EIO;
 	}
-	filesize = lseek(fd, 0L, 2);
+	filesize = sys_lseek(fd, 0L, 2);
 	if (filesize <= 0) {
 		printk(KERN_WARNING "%s: Firmware %s is empty\n", __FUNCTION__,
 		       sp887x_firmware);
@@ -244,8 +241,8 @@ int sp887x_initial_setup (struct dvb_fro
 	// read it!
 	// read the first 16384 bytes from the file
 	// ignore the first 10 bytes
-	lseek(fd, 10, 0);
-	if (read(fd, firmware, fw_size) != fw_size) {
+	sys_lseek(fd, 10, 0);
+	if (sys_read(fd, firmware, fw_size) != fw_size) {
 		printk(KERN_WARNING "%s: Failed to read firmware\n", __FUNCTION__);
 		vfree(firmware);
 		sys_close(fd);
diff -puN drivers/media/dvb/frontends/tda1004x.c~remove-more-KERNEL_SYSCALLS drivers/media/dvb/frontends/tda1004x.c
--- 25/drivers/media/dvb/frontends/tda1004x.c~remove-more-KERNEL_SYSCALLS	2004-03-07 00:17:21.000000000 -0800
+++ 25-akpm/drivers/media/dvb/frontends/tda1004x.c	2004-03-07 00:17:21.000000000 -0800
@@ -32,7 +32,6 @@
  */
 
 
-#define __KERNEL_SYSCALLS__
 #include <linux/kernel.h>
 #include <linux/vmalloc.h>
 #include <linux/module.h>
@@ -41,7 +40,6 @@
 #include <linux/slab.h>
 #include <linux/syscalls.h>
 #include <linux/fs.h>
-#include <linux/unistd.h>
 #include <linux/fcntl.h>
 #include <linux/errno.h>
 #include "dvb_frontend.h"
@@ -399,13 +397,13 @@ static int tda1004x_fwupload(struct dvb_
 
 	// Load the firmware
 	set_fs(get_ds());
-	fd = open(tda1004x_firmware, 0, 0);
+	fd = sys_open(tda1004x_firmware, 0, 0);
 	if (fd < 0) {
 		printk("%s: Unable to open firmware %s\n", __FUNCTION__,
 		       tda1004x_firmware);
 		return -EIO;
 	}
-	filesize = lseek(fd, 0L, 2);
+	filesize = sys_lseek(fd, 0L, 2);
 	if (filesize <= 0) {
 		printk("%s: Firmware %s is empty\n", __FUNCTION__,
 		       tda1004x_firmware);
@@ -436,8 +434,8 @@ static int tda1004x_fwupload(struct dvb_
 	}
 
 	// read it!
-        lseek(fd, fw_offset, 0);
-	if (read(fd, firmware, fw_size) != fw_size) {
+        sys_lseek(fd, fw_offset, 0);
+	if (sys_read(fd, firmware, fw_size) != fw_size) {
 		printk("%s: Failed to read firmware\n", __FUNCTION__);
 		vfree(firmware);
 		sys_close(fd);
diff -puN drivers/scsi/cpqfcTSinit.c~remove-more-KERNEL_SYSCALLS drivers/scsi/cpqfcTSinit.c
--- 25/drivers/scsi/cpqfcTSinit.c~remove-more-KERNEL_SYSCALLS	2004-03-07 00:17:21.000000000 -0800
+++ 25-akpm/drivers/scsi/cpqfcTSinit.c	2004-03-07 00:17:21.000000000 -0800
@@ -46,10 +46,6 @@
 #include <linux/ioport.h>  // request_region() prototype
 #include <linux/completion.h>
 
-#ifdef __alpha__
-#define __KERNEL_SYSCALLS__
-#endif
-#include <asm/unistd.h>
 #include <asm/io.h>
 #include <asm/uaccess.h>   // ioctl related
 #include <asm/irq.h>
diff -puN drivers/scsi/oktagon_esp.c~remove-more-KERNEL_SYSCALLS drivers/scsi/oktagon_esp.c
--- 25/drivers/scsi/oktagon_esp.c~remove-more-KERNEL_SYSCALLS	2004-03-07 00:17:21.000000000 -0800
+++ 25-akpm/drivers/scsi/oktagon_esp.c	2004-03-07 00:17:21.000000000 -0800
@@ -12,7 +12,6 @@
 #define USE_BOTTOM_HALF
 #endif
 
-#define __KERNEL_SYSCALLS__
 #include <linux/module.h>
 
 #include <linux/kernel.h>
@@ -43,8 +42,6 @@
 #include <linux/interrupt.h>
 #endif
 
-#include <linux/unistd.h>
-
 /* The controller registers can be found in the Z2 config area at these
  * offsets:
  */
diff -puN init/do_mounts.c~remove-more-KERNEL_SYSCALLS init/do_mounts.c
--- 25/init/do_mounts.c~remove-more-KERNEL_SYSCALLS	2004-03-07 00:17:21.000000000 -0800
+++ 25-akpm/init/do_mounts.c	2004-03-07 00:17:21.000000000 -0800
@@ -66,11 +66,11 @@ static dev_t __init try_name(char *name,
 	/* read device number from .../dev */
 
 	sprintf(path, "/sys/block/%s/dev", name);
-	fd = open(path, 0, 0);
+	fd = sys_open(path, 0, 0);
 	if (fd < 0)
 		goto fail;
-	len = read(fd, buf, 32);
-	close(fd);
+	len = sys_read(fd, buf, 32);
+	sys_close(fd);
 	if (len <= 0 || len == 32 || buf[len - 1] != '\n')
 		goto fail;
 	buf[len - 1] = '\0';
@@ -96,11 +96,11 @@ static dev_t __init try_name(char *name,
 
 	/* otherwise read range from .../range */
 	sprintf(path, "/sys/block/%s/range", name);
-	fd = open(path, 0, 0);
+	fd = sys_open(path, 0, 0);
 	if (fd < 0)
 		goto fail;
-	len = read(fd, buf, 32);
-	close(fd);
+	len = sys_read(fd, buf, 32);
+	sys_close(fd);
 	if (len <= 0 || len == 32 || buf[len - 1] != '\n')
 		goto fail;
 	buf[len - 1] = '\0';
@@ -287,7 +287,7 @@ retry:
 				continue;
 		}
 	        /*
-		 * Allow the user to distinguish between failed open
+		 * Allow the user to distinguish between failed sys_open
 		 * and bad superblock on root device.
 		 */
 		__bdevname(ROOT_DEV, b);
@@ -326,21 +326,21 @@ void __init change_floppy(char *fmt, ...
 	va_start(args, fmt);
 	vsprintf(buf, fmt, args);
 	va_end(args);
-	fd = open("/dev/root", O_RDWR | O_NDELAY, 0);
+	fd = sys_open("/dev/root", O_RDWR | O_NDELAY, 0);
 	if (fd >= 0) {
 		sys_ioctl(fd, FDEJECT, 0);
-		close(fd);
+		sys_close(fd);
 	}
 	printk(KERN_NOTICE "VFS: Insert %s and press ENTER\n", buf);
-	fd = open("/dev/console", O_RDWR, 0);
+	fd = sys_open("/dev/console", O_RDWR, 0);
 	if (fd >= 0) {
 		sys_ioctl(fd, TCGETS, (long)&termios);
 		termios.c_lflag &= ~ICANON;
 		sys_ioctl(fd, TCSETSF, (long)&termios);
-		read(fd, &c, 1);
+		sys_read(fd, &c, 1);
 		termios.c_lflag |= ICANON;
 		sys_ioctl(fd, TCSETSF, (long)&termios);
-		close(fd);
+		sys_close(fd);
 	}
 }
 #endif
diff -puN init/do_mounts_devfs.c~remove-more-KERNEL_SYSCALLS init/do_mounts_devfs.c
--- 25/init/do_mounts_devfs.c~remove-more-KERNEL_SYSCALLS	2004-03-07 00:17:21.000000000 -0800
+++ 25-akpm/init/do_mounts_devfs.c	2004-03-07 00:17:21.000000000 -0800
@@ -24,7 +24,7 @@ static int __init do_read_dir(int fd, vo
 {
 	long bytes, n;
 	char *p = buf;
-	lseek(fd, 0, 0);
+	sys_lseek(fd, 0, 0);
 
 	for (bytes = 0; bytes < len; bytes += n) {
 		n = sys_getdents64(fd, (struct linux_dirent64 *)(p + bytes),
@@ -45,7 +45,7 @@ static int __init do_read_dir(int fd, vo
 static void * __init read_dir(char *path, int *len)
 {
 	int size;
-	int fd = open(path, 0, 0);
+	int fd = sys_open(path, 0, 0);
 
 	*len = 0;
 	if (fd < 0)
@@ -58,7 +58,7 @@ static void * __init read_dir(char *path
 			break;
 		n = do_read_dir(fd, p, size);
 		if (n > 0) {
-			close(fd);
+			sys_close(fd);
 			*len = n;
 			return p;
 		}
@@ -68,7 +68,7 @@ static void * __init read_dir(char *path
 		if (n < 0)
 			break;
 	}
-	close(fd);
+	sys_close(fd);
 	return NULL;
 }
 
diff -puN init/do_mounts.h~remove-more-KERNEL_SYSCALLS init/do_mounts.h
--- 25/init/do_mounts.h~remove-more-KERNEL_SYSCALLS	2004-03-07 00:17:21.000000000 -0800
+++ 25-akpm/init/do_mounts.h	2004-03-07 00:17:21.000000000 -0800
@@ -1,4 +1,3 @@
-#define __KERNEL_SYSCALLS__
 #include <linux/config.h>
 #include <linux/kernel.h>
 #include <linux/devfs_fs_kernel.h>
diff -puN init/do_mounts_initrd.c~remove-more-KERNEL_SYSCALLS init/do_mounts_initrd.c
--- 25/init/do_mounts_initrd.c~remove-more-KERNEL_SYSCALLS	2004-03-07 00:17:21.000000000 -0800
+++ 25-akpm/init/do_mounts_initrd.c	2004-03-07 00:17:21.000000000 -0800
@@ -1,4 +1,5 @@
-
+#define __KERNEL_SYSCALLS__
+#include <linux/unistd.h>
 #include <linux/kernel.h>
 #include <linux/fs.h>
 #include <linux/minix_fs.h>
@@ -28,12 +29,12 @@ static int __init do_linuxrc(void * shel
 	static char *argv[] = { "linuxrc", NULL, };
 	extern char * envp_init[];
 
-	close(old_fd);close(root_fd);
-	close(0);close(1);close(2);
-	setsid();
-	(void) open("/dev/console",O_RDWR,0);
-	(void) dup(0);
-	(void) dup(0);
+	sys_close(old_fd);sys_close(root_fd);
+	sys_close(0);sys_close(1);sys_close(2);
+	sys_setsid();
+	(void) sys_open("/dev/console",O_RDWR,0);
+	(void) sys_dup(0);
+	(void) sys_dup(0);
 	return execve(shell, argv, envp_init);
 }
 
@@ -47,8 +48,8 @@ static void __init handle_initrd(void)
 	/* mount initrd on rootfs' /root */
 	mount_block_root("/dev/root.old", root_mountflags & ~MS_RDONLY);
 	sys_mkdir("/old", 0700);
-	root_fd = open("/", 0, 0);
-	old_fd = open("/old", 0, 0);
+	root_fd = sys_open("/", 0, 0);
+	old_fd = sys_open("/old", 0, 0);
 	/* move initrd over / and chdir/chroot in initrd root */
 	sys_chdir("/root");
 	sys_mount(".", "/", NULL, MS_MOVE, NULL);
@@ -57,7 +58,7 @@ static void __init handle_initrd(void)
 
 	pid = kernel_thread(do_linuxrc, "/linuxrc", SIGCHLD);
 	if (pid > 0) {
-		while (pid != waitpid(-1, &i, 0))
+		while (pid != sys_wait4(-1, &i, 0, 0))
 			yield();
 	}
 
@@ -67,8 +68,8 @@ static void __init handle_initrd(void)
 	/* switch root and cwd back to / of rootfs */
 	sys_fchdir(root_fd);
 	sys_chroot(".");
-	close(old_fd);
-	close(root_fd);
+	sys_close(old_fd);
+	sys_close(root_fd);
 	umount_devfs("/old/dev");
 
 	if (new_decode_dev(real_root_dev) == Root_RAM0) {
@@ -84,7 +85,7 @@ static void __init handle_initrd(void)
 	if (!error)
 		printk("okay\n");
 	else {
-		int fd = open("/dev/root.old", O_RDWR, 0);
+		int fd = sys_open("/dev/root.old", O_RDWR, 0);
 		printk("failed\n");
 		printk(KERN_NOTICE "Unmounting old root\n");
 		sys_umount("/old", MNT_DETACH);
@@ -93,7 +94,7 @@ static void __init handle_initrd(void)
 			error = fd;
 		} else {
 			error = sys_ioctl(fd, BLKFLSBUF, 0);
-			close(fd);
+			sys_close(fd);
 		}
 		printk(!error ? "okay\n" : "failed\n");
 	}
diff -puN init/do_mounts_md.c~remove-more-KERNEL_SYSCALLS init/do_mounts_md.c
--- 25/init/do_mounts_md.c~remove-more-KERNEL_SYSCALLS	2004-03-07 00:17:21.000000000 -0800
+++ 25-akpm/init/do_mounts_md.c	2004-03-07 00:17:21.000000000 -0800
@@ -154,7 +154,7 @@ static void __init md_setup_drive(void)
 
 		printk(KERN_INFO "md: Loading md%d: %s\n", minor, md_setup_args.device_names[minor]);
 
-		fd = open(name, 0, 0);
+		fd = sys_open(name, 0, 0);
 		if (fd < 0) {
 			printk(KERN_ERR "md: open failed - cannot start array %d\n", minor);
 			continue;
@@ -163,7 +163,7 @@ static void __init md_setup_drive(void)
 			printk(KERN_WARNING
 			       "md: Ignoring md=%d, already autodetected. (Use raid=noautodetect)\n",
 			       minor);
-			close(fd);
+			sys_close(fd);
 			continue;
 		}
 
@@ -209,7 +209,7 @@ static void __init md_setup_drive(void)
 			err = sys_ioctl(fd, RUN_ARRAY, 0);
 		if (err)
 			printk(KERN_WARNING "md: starting md%d failed\n", minor);
-		close(fd);
+		sys_close(fd);
 	}
 }
 
@@ -243,10 +243,10 @@ void __init md_run_setup(void)
 	if (raid_noautodetect)
 		printk(KERN_INFO "md: Skipping autodetection of RAID arrays. (raid=noautodetect)\n");
 	else {
-		int fd = open("/dev/md0", 0, 0);
+		int fd = sys_open("/dev/md0", 0, 0);
 		if (fd >= 0) {
 			sys_ioctl(fd, RAID_AUTORUN, 0);
-			close(fd);
+			sys_close(fd);
 		}
 	}
 	md_setup_drive();
diff -puN init/do_mounts_rd.c~remove-more-KERNEL_SYSCALLS init/do_mounts_rd.c
--- 25/init/do_mounts_rd.c~remove-more-KERNEL_SYSCALLS	2004-03-07 00:17:21.000000000 -0800
+++ 25-akpm/init/do_mounts_rd.c	2004-03-07 00:17:21.000000000 -0800
@@ -69,8 +69,8 @@ identify_ramdisk_image(int fd, int start
 	/*
 	 * Read block 0 to test for gzipped kernel
 	 */
-	lseek(fd, start_block * BLOCK_SIZE, 0);
-	read(fd, buf, size);
+	sys_lseek(fd, start_block * BLOCK_SIZE, 0);
+	sys_read(fd, buf, size);
 
 	/*
 	 * If it matches the gzip magic numbers, return -1
@@ -104,8 +104,8 @@ identify_ramdisk_image(int fd, int start
 	/*
 	 * Read block 1 to test for minix and ext2 superblock
 	 */
-	lseek(fd, (start_block+1) * BLOCK_SIZE, 0);
-	read(fd, buf, size);
+	sys_lseek(fd, (start_block+1) * BLOCK_SIZE, 0);
+	sys_read(fd, buf, size);
 
 	/* Try minix */
 	if (minixsb->s_magic == MINIX_SUPER_MAGIC ||
@@ -131,7 +131,7 @@ identify_ramdisk_image(int fd, int start
 	       start_block);
 	
 done:
-	lseek(fd, start_block * BLOCK_SIZE, 0);
+	sys_lseek(fd, start_block * BLOCK_SIZE, 0);
 	kfree(buf);
 	return nblocks;
 }
@@ -148,11 +148,11 @@ int __init rd_load_image(char *from)
 	char rotator[4] = { '|' , '/' , '-' , '\\' };
 #endif
 
-	out_fd = open("/dev/ram", O_RDWR, 0);
+	out_fd = sys_open("/dev/ram", O_RDWR, 0);
 	if (out_fd < 0)
 		goto out;
 
-	in_fd = open(from, O_RDONLY, 0);
+	in_fd = sys_open(from, O_RDONLY, 0);
 	if (in_fd < 0)
 		goto noclose_input;
 
@@ -217,20 +217,20 @@ int __init rd_load_image(char *from)
 		if (i && (i % devblocks == 0)) {
 			printk("done disk #%d.\n", disk++);
 			rotate = 0;
-			if (close(in_fd)) {
+			if (sys_close(in_fd)) {
 				printk("Error closing the disk.\n");
 				goto noclose_input;
 			}
 			change_floppy("disk #%d", disk);
-			in_fd = open(from, O_RDONLY, 0);
+			in_fd = sys_open(from, O_RDONLY, 0);
 			if (in_fd < 0)  {
 				printk("Error opening disk.\n");
 				goto noclose_input;
 			}
 			printk("Loading disk #%d... ", disk);
 		}
-		read(in_fd, buf, BLOCK_SIZE);
-		write(out_fd, buf, BLOCK_SIZE);
+		sys_read(in_fd, buf, BLOCK_SIZE);
+		sys_write(out_fd, buf, BLOCK_SIZE);
 #if !defined(CONFIG_ARCH_S390) && !defined(CONFIG_PPC_ISERIES)
 		if (!(i % 16)) {
 			printk("%c\b", rotator[rotate & 0x3]);
@@ -243,9 +243,9 @@ int __init rd_load_image(char *from)
 successful_load:
 	res = 1;
 done:
-	close(in_fd);
+	sys_close(in_fd);
 noclose_input:
-	close(out_fd);
+	sys_close(out_fd);
 out:
 	kfree(buf);
 	sys_unlink("/dev/ram");
@@ -342,7 +342,7 @@ static int __init fill_inbuf(void)
 {
 	if (exit_code) return -1;
 	
-	insize = read(crd_infd, inbuf, INBUFSIZ);
+	insize = sys_read(crd_infd, inbuf, INBUFSIZ);
 	if (insize == 0) {
 		error("RAMDISK: ran out of compressed data");
 		return -1;
@@ -363,7 +363,7 @@ static void __init flush_window(void)
     unsigned n, written;
     uch *in, ch;
     
-    written = write(crd_outfd, window, outcnt);
+    written = sys_write(crd_outfd, window, outcnt);
     if (written != outcnt && unzip_error == 0) {
 	printk(KERN_ERR "RAMDISK: incomplete write (%d != %d) %ld\n",
 	       written, outcnt, bytes_out);
diff -puN init/initramfs.c~remove-more-KERNEL_SYSCALLS init/initramfs.c
--- 25/init/initramfs.c~remove-more-KERNEL_SYSCALLS	2004-03-07 00:17:21.000000000 -0800
+++ 25-akpm/init/initramfs.c	2004-03-07 00:17:21.000000000 -0800
@@ -1,10 +1,8 @@
-#define __KERNEL_SYSCALLS__
 #include <linux/init.h>
 #include <linux/fs.h>
 #include <linux/slab.h>
 #include <linux/types.h>
 #include <linux/fcntl.h>
-#include <linux/unistd.h>
 #include <linux/delay.h>
 #include <linux/string.h>
 #include <linux/syscalls.h>
diff -puN init/main.c~remove-more-KERNEL_SYSCALLS init/main.c
--- 25/init/main.c~remove-more-KERNEL_SYSCALLS	2004-03-07 00:17:21.000000000 -0800
+++ 25-akpm/init/main.c	2004-03-07 00:17:21.000000000 -0800
@@ -18,7 +18,6 @@
 #include <linux/devfs_fs_kernel.h>
 #include <linux/kernel.h>
 #include <linux/syscalls.h>
-#include <linux/unistd.h>
 #include <linux/string.h>
 #include <linux/ctype.h>
 #include <linux/delay.h>
@@ -41,6 +40,7 @@
 #include <linux/writeback.h>
 #include <linux/cpu.h>
 #include <linux/efi.h>
+#include <linux/unistd.h>
 
 #include <asm/io.h>
 #include <asm/bugs.h>
@@ -618,11 +618,11 @@ static int init(void * unused)
 	unlock_kernel();
 	system_running = 1;
 
-	if (open("/dev/console", O_RDWR, 0) < 0)
+	if (sys_open("/dev/console", O_RDWR, 0) < 0)
 		printk("Warning: unable to open an initial console.\n");
 
-	(void) dup(0);
-	(void) dup(0);
+	(void) sys_dup(0);
+	(void) sys_dup(0);
 	
 	/*
 	 * We try each of these until one succeeds.
diff -puN sound/isa/wavefront/wavefront_synth.c~remove-more-KERNEL_SYSCALLS sound/isa/wavefront/wavefront_synth.c
--- 25/sound/isa/wavefront/wavefront_synth.c~remove-more-KERNEL_SYSCALLS	2004-03-07 00:17:21.000000000 -0800
+++ 25-akpm/sound/isa/wavefront/wavefront_synth.c	2004-03-07 00:17:21.000000000 -0800
@@ -1913,11 +1913,11 @@ wavefront_reset_to_cleanliness (snd_wave
 	return (1);
 }
 
-#define __KERNEL_SYSCALLS__
 #include <linux/fs.h>
 #include <linux/mm.h>
 #include <linux/slab.h>
 #include <linux/unistd.h>
+#include <linux/syscalls.h>
 #include <asm/uaccess.h>
 
 static int errno;
@@ -1947,7 +1947,7 @@ wavefront_download_firmware (snd_wavefro
 	fs = get_fs();
 	set_fs (get_ds());
 
-	if ((fd = open (path, 0, 0)) < 0) {
+	if ((fd = sys_open (path, 0, 0)) < 0) {
 		snd_printk ("Unable to load \"%s\".\n",
 			path);
 		return 1;
@@ -1956,7 +1956,7 @@ wavefront_download_firmware (snd_wavefro
 	while (1) {
 		int x;
 
-		if ((x = read (fd, &section_length, sizeof (section_length))) !=
+		if ((x = sys_read (fd, &section_length, sizeof (section_length))) !=
 		    sizeof (section_length)) {
 			snd_printk ("firmware read error.\n");
 			goto failure;
@@ -1966,7 +1966,7 @@ wavefront_download_firmware (snd_wavefro
 			break;
 		}
 
-		if (read (fd, section, section_length) != section_length) {
+		if (sys_read (fd, section, section_length) != section_length) {
 			snd_printk ("firmware section "
 				"read error.\n");
 			goto failure;
@@ -2005,12 +2005,12 @@ wavefront_download_firmware (snd_wavefro
 
 	}
 
-	close (fd);
+	sys_close (fd);
 	set_fs (fs);
 	return 0;
 
  failure:
-	close (fd);
+	sys_close (fd);
 	set_fs (fs);
 	snd_printk ("firmware download failed!!!\n");
 	return 1;
diff -puN sound/oss/wavfront.c~remove-more-KERNEL_SYSCALLS sound/oss/wavfront.c
--- 25/sound/oss/wavfront.c~remove-more-KERNEL_SYSCALLS	2004-03-07 00:17:21.000000000 -0800
+++ 25-akpm/sound/oss/wavfront.c	2004-03-07 00:17:21.000000000 -0800
@@ -2489,11 +2489,9 @@ static int __init detect_wavefront (int 
 }
 
 #include "os.h"
-#define __KERNEL_SYSCALLS__
 #include <linux/fs.h>
 #include <linux/mm.h>
 #include <linux/slab.h>
-#include <linux/unistd.h>
 #include <asm/uaccess.h>
 
 static int errno; 
@@ -2523,7 +2521,7 @@ wavefront_download_firmware (char *path)
 	fs = get_fs();
 	set_fs (get_ds());
 
-	if ((fd = open (path, 0, 0)) < 0) {
+	if ((fd = sys_open (path, 0, 0)) < 0) {
 		printk (KERN_WARNING LOGNAME "Unable to load \"%s\".\n",
 			path);
 		return 1;
@@ -2532,7 +2530,7 @@ wavefront_download_firmware (char *path)
 	while (1) {
 		int x;
 
-		if ((x = read (fd, &section_length, sizeof (section_length))) !=
+		if ((x = sys_read (fd, &section_length, sizeof (section_length))) !=
 		    sizeof (section_length)) {
 			printk (KERN_ERR LOGNAME "firmware read error.\n");
 			goto failure;
@@ -2542,7 +2540,7 @@ wavefront_download_firmware (char *path)
 			break;
 		}
 
-		if (read (fd, section, section_length) != section_length) {
+		if (sys_read (fd, section, section_length) != section_length) {
 			printk (KERN_ERR LOGNAME "firmware section "
 				"read error.\n");
 			goto failure;
@@ -2581,12 +2579,12 @@ wavefront_download_firmware (char *path)
 
 	}
 
-	close (fd);
+	sys_close (fd);
 	set_fs (fs);
 	return 0;
 
  failure:
-	close (fd);
+	sys_close (fd);
 	set_fs (fs);
 	printk (KERN_ERR "\nWaveFront: firmware download failed!!!\n");
 	return 1;
diff -puN include/asm-i386/unistd.h~remove-more-KERNEL_SYSCALLS include/asm-i386/unistd.h
--- 25/include/asm-i386/unistd.h~remove-more-KERNEL_SYSCALLS	2004-03-07 00:17:21.000000000 -0800
+++ 25-akpm/include/asm-i386/unistd.h	2004-03-07 00:17:21.000000000 -0800
@@ -375,6 +375,7 @@ __syscall_return(type,__res); \
 
 #include <linux/compiler.h>
 #include <linux/types.h>
+#include <linux/linkage.h>
 #include <asm/ptrace.h>
 
 /*

_
